#pragma semicolon 1
#pragma newdecls required
#include <sourcemod>
#include <sdktools>
#include <ps_natives>

#define PLUGIN_VERSION "2.0.0"
#define PS_ModuleName "\nBESS (Buy Extended Support Structure)"

#define MSGTAG "\x04[PS]\x01"

public Plugin myinfo =
{
	name = "[PS] Buy Extended Support Structure",
	author = "McFlurry, evilmaniac, and modified by Psykotik",
	description = "Module to extend buy support",
	version = PLUGIN_VERSION
}

enum module_settings
{
	Float:fVersion,
	Float:fMinLibraryVersion,
	Handle:hVersion,
	Handle:hEnabled,
	bool:bModuleLoaded
}
int ModuleSettings[module_settings];

void initPluginSettings()
{
	ModuleSettings[fVersion] = 2.00;
	ModuleSettings[fMinLibraryVersion] = 1.77;

	ModuleSettings[hVersion] = CreateConVar("em_ps_bess", PLUGIN_VERSION, "PS Bess version", FCVAR_NOTIFY|FCVAR_DONTRECORD|FCVAR_REPLICATED);
	ModuleSettings[hEnabled] = CreateConVar("ps_bess_enable", "1", "Enable BESS Module", 0, true, 0.0, true, 1.0);
	ModuleSettings[bModuleLoaded] = false;
	return;
}

StringMap hItemMap = null;
StringMap hPriceMap = null;

void populateMaps()
{
	////// Health Items
	// Pills
	hItemMap.SetString("pills", "give pain_pills", true);
	hPriceMap.SetValue("pills", FindConVar("l4d2_points_pills").IntValue, true);


	// First Aid Kit
	hItemMap.SetString("kit", "give first_aid_kit", true);
	hPriceMap.SetValue("kit", FindConVar("l4d2_points_kit").IntValue, true);

	hItemMap.SetString("medkit", "give first_aid_kit", true);
	hPriceMap.SetValue("medkit", FindConVar("l4d2_points_kit").IntValue, true);

	hItemMap.SetString("firstaid", "give first_aid_kit", true);
	hPriceMap.SetValue("firstaid", FindConVar("l4d2_points_kit").IntValue, true);

	hItemMap.SetString("firstaidkit", "give first_aid_kit", true);
	hPriceMap.SetValue("firstaidkit", FindConVar("l4d2_points_kit").IntValue, true);


	// Defibrillator
	hItemMap.SetString("defib", "give defibrillator", true);
	hPriceMap.SetValue("defib", FindConVar("l4d2_points_defib").IntValue, true);


	// Adrenaline
	hItemMap.SetString("shot", "give adrenaline", true);
	hPriceMap.SetValue("shot", FindConVar("l4d2_points_adrenaline").IntValue, true);

	hItemMap.SetString("adren", "give adrenaline", true);
	hPriceMap.SetValue("adren", FindConVar("l4d2_points_adrenaline").IntValue, true);

	hItemMap.SetString("adrenaline", "give adrenaline", true);
	hPriceMap.SetValue("adrenaline", FindConVar("l4d2_points_adrenaline").IntValue, true);


	// Health
	hItemMap.SetString("health", "give health", true);
	hPriceMap.SetValue("health", FindConVar("l4d2_points_survivor_heal").IntValue, true);

	hItemMap.SetString("fullhealth", "give health", true);
	hPriceMap.SetValue("fullhealth", FindConVar("l4d2_points_survivor_heal").IntValue, true);

	hItemMap.SetString("heal", "give health", true);
	hPriceMap.SetValue("heal", FindConVar("l4d2_points_survivor_heal").IntValue, true);

	hItemMap.SetString("fullheal", "give health", true);
	hPriceMap.SetValue("fullheal", FindConVar("l4d2_points_survivor_heal").IntValue, true);




	////// Secondary Pistols
	// Pistol
	hItemMap.SetString("pistol", "give pistol", true);
	hPriceMap.SetValue("pistol", FindConVar("l4d2_points_pistol").IntValue, true);


	// Magnum
	hItemMap.SetString("magnum", "give pistol_magnum", true);
	hPriceMap.SetValue("magnum", FindConVar("l4d2_points_magnum").IntValue, true);

	hItemMap.SetString("deagle", "give pistol_magnum", true);
	hPriceMap.SetValue("deagle", FindConVar("l4d2_points_magnum").IntValue, true);




	////// SMGs
	// SMG
	hItemMap.SetString("smg", "give smg", true);
	hPriceMap.SetValue("smg", FindConVar("l4d2_points_smg").IntValue, true);


	// Silenced SMG
	hItemMap.SetString("silenced", "give smg_silenced", true);
	hPriceMap.SetValue("silenced", FindConVar("l4d2_points_ssmg").IntValue, true);


	// MP5
	hItemMap.SetString("mp5", "give smg_mp5", true);
	hPriceMap.SetValue("mp5", FindConVar("l4d2_points_mp5").IntValue, true);




	////// Rifles
	// M16
	hItemMap.SetString("m16", "give rifle", true);
	hPriceMap.SetValue("m16", FindConVar("l4d2_points_m16").IntValue, true);

	hItemMap.SetString("rifle", "give rifle", true);
	hPriceMap.SetValue("rifle", FindConVar("l4d2_points_m16").IntValue, true);


	// SCAR
	hItemMap.SetString("scar", "give rifle_desert", true);
	hPriceMap.SetValue("scar", FindConVar("l4d2_points_scar").IntValue, true);

	hItemMap.SetString("desert", "give rifle_desert", true);
	hPriceMap.SetValue("scar", FindConVar("l4d2_points_scar").IntValue, true);


	// AK47
	hItemMap.SetString("ak", "give rifle_ak47", true);
	hPriceMap.SetValue("ak", FindConVar("l4d2_points_ak").IntValue, true);

	hItemMap.SetString("ak47", "give rifle_ak47", true);
	hPriceMap.SetValue("ak47", FindConVar("l4d2_points_ak").IntValue, true);


	// SG552
	hItemMap.SetString("sg", "give rifle_sg552", true);
	hPriceMap.SetValue("sg", FindConVar("l4d2_points_sg").IntValue, true);

	hItemMap.SetString("sg552", "give rifle_sg552", true);
	hPriceMap.SetValue("sg552", FindConVar("l4d2_points_sg").IntValue, true);


	// M60
	hItemMap.SetString("m60", "give rifle_m60", true);
	hPriceMap.SetValue("m60", FindConVar("l4d2_points_m60").IntValue, true);

	hItemMap.SetString("machinegun", "give rifle_m60", true);
	hPriceMap.SetValue("machinegun", FindConVar("l4d2_points_m60").IntValue, true);




	////// Sniper
	// Hunting Rifle
	hItemMap.SetString("sniper", "give hunting_rifle", true);
	hPriceMap.SetValue("sniper", FindConVar("l4d2_points_hunting_rifle").IntValue, true);

	hItemMap.SetString("huntingrifle", "give hunting_rifle", true);
	hPriceMap.SetValue("huntingrifle", FindConVar("l4d2_points_hunting_rifle").IntValue, true);


	// Scout
	hItemMap.SetString("scout", "give sniper_scout", true);
	hPriceMap.SetValue("scout", FindConVar("l4d2_points_scout").IntValue, true);


	// Military Sniper
	hItemMap.SetString("military", "give sniper_military", true);
	hPriceMap.SetValue("military", FindConVar("l4d2_points_military_sniper").IntValue, true);


	// AWP
	hItemMap.SetString("awp", "give sniper_awp", true);
	hPriceMap.SetValue("awp", FindConVar("l4d2_points_awp").IntValue, true);




	////// Shotguns
	// Chrome Shotgun
	hItemMap.SetString("chrome", "give shotgun_chrome", true);
	hPriceMap.SetValue("chrome", FindConVar("l4d2_points_chrome").IntValue, true);

	hItemMap.SetString("chromeshotgun", "give shotgun_chrome", true);
	hPriceMap.SetValue("chromeshotgun", FindConVar("l4d2_points_chrome").IntValue, true);


	// Pump Shotgun
	hItemMap.SetString("pump", "give pumpshotgun", true);
	hPriceMap.SetValue("pump", FindConVar("l4d2_points_pump").IntValue, true);

	hItemMap.SetString("pumpshotgun", "give pumpshotgun", true);
	hPriceMap.SetValue("pumpshotgun", FindConVar("l4d2_points_pump").IntValue, true);


	// SPAS Shotgun
	hItemMap.SetString("spas", "give shotgun_spas", true);
	hPriceMap.SetValue("spas", FindConVar("l4d2_points_spas").IntValue, true);

	hItemMap.SetString("spasshotgun", "give shotgun_spas", true);
	hPriceMap.SetValue("spasshotgun", FindConVar("l4d2_points_spas").IntValue, true);


	// Auto Shotgun
	hItemMap.SetString("auto", "give autoshotgun", true);
	hPriceMap.SetValue("auto", FindConVar("l4d2_points_autoshotgun").IntValue, true);

	hItemMap.SetString("autoshotgun", "give autoshotgun", true);
	hPriceMap.SetValue("autoshotgun", FindConVar("l4d2_points_autoshotgun").IntValue, true);




	////// Throwables
	// Molotov
	hItemMap.SetString("mol", "give molotov", true);
	hPriceMap.SetValue("mol", FindConVar("l4d2_points_molotov").IntValue, true);

	hItemMap.SetString("molotov", "give molotov", true);
	hPriceMap.SetValue("molotov", FindConVar("l4d2_points_molotov").IntValue, true);


	// Pipe Bomb
	hItemMap.SetString("pipe", "give pipe_bomb", true);
	hPriceMap.SetValue("pipe", FindConVar("l4d2_points_pipe").IntValue, true);

	hItemMap.SetString("pipebomb", "give pipe_bomb", true);
	hPriceMap.SetValue("pipebomb", FindConVar("l4d2_points_pipe").IntValue, true);


	// Vomit/Bile Jar
	hItemMap.SetString("bile", "give vomitjar", true);
	hPriceMap.SetValue("bile", FindConVar("l4d2_points_bile").IntValue, true);

	hItemMap.SetString("bilejar", "give vomitjar", true);
	hPriceMap.SetValue("bilejar", FindConVar("l4d2_points_bile").IntValue, true);




	////// Misc
	// Chainsaw
	hItemMap.SetString("chainsaw", "give chainsaw", true);
	hPriceMap.SetValue("chainsaw", FindConVar("l4d2_points_chainsaw").IntValue, true);


	// Grenade Launcher
	hItemMap.SetString("grenade", "give grenade_launcher", true);
	hPriceMap.SetValue("grenade", FindConVar("l4d2_points_grenade").IntValue, true);

	hItemMap.SetString("grenadelauncher", "give grenade_launcher", true);
	hPriceMap.SetValue("grenadelauncher", FindConVar("l4d2_points_grenade").IntValue, true);


	// Gnome
	hItemMap.SetString("gnome", "give gnome", true);
	hPriceMap.SetValue("gnome", FindConVar("l4d2_points_gnome").IntValue, true);


	// Cola
	hItemMap.SetString("cola", "give cola_bottles", true);
	hPriceMap.SetValue("cola", FindConVar("l4d2_points_cola").IntValue, true);


	// Gas Can
	hItemMap.SetString("gas", "give gascan", true);
	hPriceMap.SetValue("gas", FindConVar("l4d2_points_gascan").IntValue, true);

	hItemMap.SetString("gascas", "give gascan", true);
	hPriceMap.SetValue("gascan", FindConVar("l4d2_points_gascan").IntValue, true);


	// Propane Tank
	hItemMap.SetString("propane", "give propanetank", true);
	hPriceMap.SetValue("propane", FindConVar("l4d2_points_propane").IntValue, true);

	hItemMap.SetString("propanetank", "give propanetank", true);
	hPriceMap.SetValue("propanetank", FindConVar("l4d2_points_propane").IntValue, true);


	// Fireworks
	hItemMap.SetString("fireworks", "give fireworkcrate", true);
	hPriceMap.SetValue("fireworks", FindConVar("l4d2_points_fireworks").IntValue, true);


	// Oxygen Tank
	hItemMap.SetString("oxygen", "give oxygentank", true);
	hPriceMap.SetValue("oxygen", FindConVar("l4d2_points_oxygen").IntValue, true);

	hItemMap.SetString("oxygentank", "give oxygentank", true);
	hPriceMap.SetValue("oxygentank", FindConVar("l4d2_points_oxygen").IntValue, true);




	////// Upgrades
	// Explosive Ammo Pack
	hItemMap.SetString("packex", "give upgradepack_explosive", true);
	hPriceMap.SetValue("packex", FindConVar("l4d2_points_explosive_ammo_pack").IntValue, true);


	// Incendiary Ammo Pack
	hItemMap.SetString("packin", "give upgradepack_incendiary", true);
	hPriceMap.SetValue("packin", FindConVar("l4d2_points_incendiary_ammo_pack").IntValue, true);


	// Ammo
	hItemMap.SetString("ammo", "give ammo", true);
	hPriceMap.SetValue("ammo", FindConVar("l4d2_points_refill").IntValue, true);


	// Explosive Ammo
	hItemMap.SetString("exammo", "upgrade_add EXPLOSIVE_AMMO", true);
	hPriceMap.SetValue("exammo", FindConVar("l4d2_points_explosive_ammo").IntValue, true);


	// Incendiary Ammo
	hItemMap.SetString("inammo", "upgrade_add INCENDIARY_AMMO", true);
	hPriceMap.SetValue("inammo", FindConVar("l4d2_points_incendiary_ammo").IntValue, true);


	// Laser
	hItemMap.SetString("laser", "upgrade_add LASER_SIGHT", true);
	hPriceMap.SetValue("laser", FindConVar("l4d2_points_laser").IntValue, true);




	////// Melee
	// Baseball Bat
	hItemMap.SetString("bat", "give baseball_bat", true);
	hPriceMap.SetValue("bat", FindConVar("l4d2_points_bat").IntValue, true);

	hItemMap.SetString("baseballbat", "give baseball_bat", true);
	hPriceMap.SetValue("baseballbat", FindConVar("l4d2_points_bat").IntValue, true);


	// Cricket Bat
	hItemMap.SetString("cricket", "give cricket_bat", true);
	hPriceMap.SetValue("cricket", FindConVar("l4d2_points_cricketbat").IntValue, true);

	hItemMap.SetString("cricketbat", "give cricket_bat", true);
	hPriceMap.SetValue("cricketbat", FindConVar("l4d2_points_cricketbat").IntValue, true);


	// Crowbar
	hItemMap.SetString("crowbar", "give crowbar", true);
	hPriceMap.SetValue("crowbar", FindConVar("l4d2_points_crowbar").IntValue, true);


	// Guitar
	hItemMap.SetString("guitar", "give electric_guitar", true);
	hPriceMap.SetValue("guitar", FindConVar("l4d2_points_guitar").IntValue, true);


	// Fire Axe
	hItemMap.SetString("axe", "give fireaxe", true);
	hPriceMap.SetValue("axe", FindConVar("l4d2_points_fireaxe").IntValue, true);

	hItemMap.SetString("fireaxe", "give fireaxe", true);
	hPriceMap.SetValue("fireaxe", FindConVar("l4d2_points_fireaxe").IntValue, true);


	// Frying Pan
	hItemMap.SetString("pan", "give frying_pan", true);
	hPriceMap.SetValue("pan", FindConVar("l4d2_points_pan").IntValue, true);

	hItemMap.SetString("frying_pan", "give frying_pan", true);
	hPriceMap.SetValue("frying_pan", FindConVar("l4d2_points_pan").IntValue, true);


	// Golf Club
	hItemMap.SetString("club", "give golfclub", true);
	hPriceMap.SetValue("club", FindConVar("l4d2_points_golfclub").IntValue, true);

	hItemMap.SetString("golfclub", "give golfclub", true);
	hPriceMap.SetValue("golfclub", FindConVar("l4d2_points_golfclub").IntValue, true);


	// Katana
	hItemMap.SetString("katana", "give katana", true);
	hPriceMap.SetValue("katana", FindConVar("l4d2_points_katana").IntValue, true);

	hItemMap.SetString("ninja", "give katana", true);
	hPriceMap.SetValue("ninja", FindConVar("l4d2_points_katana").IntValue, true);


	// Machete
	hItemMap.SetString("machete", "give machete", true);
	hPriceMap.SetValue("machete", FindConVar("l4d2_points_machete").IntValue, true);


	// Tonfa
	hItemMap.SetString("tonfa", "give tonfa", true);
	hPriceMap.SetValue("tonfa", FindConVar("l4d2_points_tonfa").IntValue, true);

	hItemMap.SetString("nightstick", "give tonfa", true);
	hPriceMap.SetValue("nightstick", FindConVar("l4d2_points_tonfa").IntValue, true);




	return;
}

void buildMap()
{
	hItemMap = new StringMap();
	hPriceMap = new StringMap();
	populateMaps();
	return;
}

void registerConsoleCommands()
{
	RegConsoleCmd("sm_b", Cmd_Buy);
	RegConsoleCmd("sm_buy", Cmd_Buy);
	RegConsoleCmd("sm_buystuff", Cmd_Buy);
	return;
}

bool IsModuleActive()
{
	if (GetConVarBool(ModuleSettings[hEnabled]) && ModuleSettings[bModuleLoaded] && PS_IsSystemEnabled())
	{
		return true;
	}
	return false;
}

public void OnPluginStart()
{
	char game_name[64];
	GetGameFolderName(game_name, sizeof(game_name));
	if (!StrEqual(game_name, "left4dead2", false))
	{
		SetFailState("%T", "Game Check Fail", LANG_SERVER);
	}
	else
	{
		initPluginSettings();
		registerConsoleCommands();

		AutoExecConfig(true, "ps_bess");
		LoadTranslations("points_system.phrases");
	}
	return;
}

public void OnAllPluginsLoaded()
{
	if (LibraryExists("ps_natives"))
	{
		if (PS_GetVersion() >= ModuleSettings[fMinLibraryVersion])
		{
			// If module registeration has failed
			if (!PS_RegisterModule(PS_ModuleName))
			{
				LogMessage("[PS] Plugin already registered.");
			}
			else
			{
				buildMap();
				ModuleSettings[bModuleLoaded] = true;
				return;
			}
		}
		else
		{
			SetFailState("[PS] Outdated version of Points System installed.");
		}
	}
	else
	{
		SetFailState("[PS] PS Natives are not loaded.");
	}
	return;
}

public void OnPluginEnd()
{
	PS_UnregisterModule(PS_ModuleName);

	hItemMap.Clear();
	hPriceMap.Clear();

	return;
}

public void OnPSUnloaded()
{
	ModuleSettings[bModuleLoaded] = false;
	return;
}

public void OnConfigsExecuted()
{
	hItemMap.Clear();
	hPriceMap.Clear();
	buildMap();
	return;
}

bool checkDisabled(int iCost)
{
	if (iCost <= -1) return true;
	else return false;
}

bool checkPoints(int iClientIndex, int iCost)
{
	if (PS_GetPoints(iClientIndex) >= iCost) return true;
	else PrintToChat(iClientIndex, "%s %T", MSGTAG, "Insufficient Funds", LANG_SERVER);

	return false;
}

bool hasEnoughPoints(int iClientIndex, int iCost)
{
	return checkPoints(iClientIndex, iCost);
}

void removePoints(int iClientIndex, int iPoints)
{
	PS_RemovePoints(iClientIndex, iPoints);
	return;
}

public Action Cmd_Buy(int iClientIndex, int iNumArgs)
{
	if(iNumArgs != 1)
	{
		return Plugin_Continue;
	}

	if(!IsModuleActive() || !IsClientInGame(iClientIndex) || iClientIndex > MaxClients)
	{
		return Plugin_Continue;
	}

	if(!IsPlayerAlive(iClientIndex))
	{
		ReplyToCommand(iClientIndex, "[PS] Must Be Alive To Buy Items!");
		return Plugin_Continue;
	}

	char sPlayerInput[50];
	sPlayerInput[0] = '\0';

	char sPurchaseCmd[100];
	sPurchaseCmd[0] = '\0';

	GetCmdArg(1, sPlayerInput, sizeof(sPlayerInput));

	if (hItemMap.GetString(sPlayerInput, sPurchaseCmd, sizeof(sPurchaseCmd)))
	{
		// -2 = invalid
		int iCost = -2;

		if (hPriceMap.GetValue(sPlayerInput, iCost) && !checkDisabled(iCost) && GetClientTeam(iClientIndex) == 2)
		{
			performPurchase(iClientIndex, iCost, sPurchaseCmd);
		}
	}
	return Plugin_Continue;
}

bool IsCarryingWeapon(int iClientIndex)
{
	int iWeapon = GetPlayerWeaponSlot(iClientIndex, 0);
	if (iWeapon == -1) return false;
	else return true;
}

public void reloadAmmo(int iClientIndex, int iCost, const char[] sItem)
{
	int hWeapon = GetPlayerWeaponSlot(iClientIndex, 0);
	if (IsCarryingWeapon(iClientIndex))
	{
		char sWeapon[40];
		sWeapon[0] = '\0';

		GetEdictClassname(hWeapon, sWeapon, sizeof(sWeapon));
		if (StrEqual(sWeapon, "weapon_rifle_m60", false))
		{
			int iAmmo_m60 = 150;
			Handle hGunControl_m60 = FindConVar("l4d2_guncontrol_m60ammo");
			if (hGunControl_m60 != null)
			{
				iAmmo_m60 = GetConVarInt(hGunControl_m60);
				CloseHandle(hGunControl_m60);
			}
			SetEntProp(hWeapon, Prop_Data, "m_iClip1", iAmmo_m60, 1);
		}
		else if (StrEqual(sWeapon, "weapon_grenade_launcher", false))
		{
			int iAmmo_Launcher = 30;
			Handle hGunControl_Launcher = FindConVar("l4d2_guncontrol_grenadelauncherammo");
			if (hGunControl_Launcher != null)
			{
				iAmmo_Launcher = GetConVarInt(hGunControl_Launcher);
				CloseHandle(hGunControl_Launcher);
			}
			int uOffset = FindDataMapInfo(iClientIndex, "m_iAmmo");
			SetEntData(iClientIndex, uOffset + 68, iAmmo_Launcher);
		}
		execClientCommand(iClientIndex, sItem);
		removePoints(iClientIndex, iCost);
	}
	else
	{
		PrintToChat(iClientIndex, "%s %T", MSGTAG, "Primary Warning", LANG_SERVER);
	}
	return;
}

// We are doing this so !repeatbuy works
void setLastPurchase(int iClientIndex, int iCost, const char[] sPurchaseCmd)
{
	PS_SetItem(iClientIndex, sPurchaseCmd);
	PS_SetCost(iClientIndex, iCost);
	return;
}

// sItem[] should be const
void performPurchase(int iClientIndex, int iCost, const char[] sPurchaseCmd)
{
	if (iCost >= 0)
	{
		if (hasEnoughPoints(iClientIndex, iCost))
		{
			if (StrEqual(sPurchaseCmd, "give ammo", false))
			{
				reloadAmmo(iClientIndex, iCost, sPurchaseCmd);
				setLastPurchase(iClientIndex, iCost, sPurchaseCmd);
			}
			else
			{
				execClientCommand(iClientIndex, sPurchaseCmd);
				removePoints(iClientIndex, iCost);
				setLastPurchase(iClientIndex, iCost, sPurchaseCmd);
			}
		}
		else
		{
			PrintToChat(iClientIndex, "%s %T", MSGTAG, "Insufficient Funds", LANG_SERVER);
		}
	}
	return;
}

void execClientCommand(int iClientIndex, const char[] sCommand){
	RemoveFlags();
	int userflags = GetUserFlagBits(iClientIndex);
	SetUserFlagBits(iClientIndex, ADMFLAG_ROOT);
	FakeClientCommand(iClientIndex, sCommand);
	SetUserFlagBits(iClientIndex, userflags);
	AddFlags();
	return;
}

void RemoveFlags()
{
	int flagsgive = GetCommandFlags("give");
	int flagszspawn = GetCommandFlags("z_spawn_old");
	int flagsupgradeadd = GetCommandFlags("upgrade_add");
	int flagspanic = GetCommandFlags("director_force_panic_event");
	SetCommandFlags("give", flagsgive & ~FCVAR_CHEAT);
	SetCommandFlags("z_spawn_old", flagszspawn & ~FCVAR_CHEAT);
	SetCommandFlags("upgrade_add", flagsupgradeadd & ~FCVAR_CHEAT);
	SetCommandFlags("director_force_panic_event", flagspanic & ~FCVAR_CHEAT);
	return;
}

void AddFlags()
{
	int flagsgive = GetCommandFlags("give");
	int flagszspawn = GetCommandFlags("z_spawn_old");
	int flagsupgradeadd = GetCommandFlags("upgrade_add");
	int flagspanic = GetCommandFlags("director_force_panic_event");
	SetCommandFlags("give", flagsgive|FCVAR_CHEAT);
	SetCommandFlags("z_spawn_old", flagszspawn|FCVAR_CHEAT);
	SetCommandFlags("upgrade_add", flagsupgradeadd|FCVAR_CHEAT);
	SetCommandFlags("director_force_panic_event", flagspanic|FCVAR_CHEAT);
	return;
}
